(HERALD XWS2 (ENV TSYS (XLIB INTERFACE)))

(DEFINE-FOREIGN XOPENDISPLAY* ("XOpenDisplay" (IN REP/STRING)) REP/POINTER)
(DEFINE (XOPENDISPLAY DISPLAY)
        (LET* ((DISPLAY (IF (STRING? DISPLAY)
                            (STRING->ASCIZ! DISPLAY)
                            (ERROR "Argument is incorrect type: ~s" DISPLAY)))
               (RETURN-VALUE (CONS 'DISPLAYP (XOPENDISPLAY* DISPLAY))))
              RETURN-VALUE))
(DEFINE-FOREIGN XALLPLANES* ("XAllPlanes") REP/INTEGER)
(DEFINE (XALLPLANES) (LET* ((RETURN-VALUE (XALLPLANES*))) RETURN-VALUE))
(DEFINE-FOREIGN XBLACKPIXEL*
                ("XBlackPixel" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XBLACKPIXEL DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XBLACKPIXEL* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XWHITEPIXEL*
                ("XWhitePixel" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XWHITEPIXEL DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XWHITEPIXEL* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XCONNECTIONNUMBER*
                ("XConnectionNumber" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XCONNECTIONNUMBER DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XCONNECTIONNUMBER* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTCOLORMAP*
                ("XDefaultColormap" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XDEFAULTCOLORMAP DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XDEFAULTCOLORMAP* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTDEPTH*
                ("XDefaultDepth" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XDEFAULTDEPTH DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XDEFAULTDEPTH* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTGC*
                ("XDefaultGC" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/POINTER)
(DEFINE (XDEFAULTGC DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (CONS 'GC (XDEFAULTGC* DPY SCR))))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTROOTWINDOW*
                ("XDefaultRootWindow" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XDEFAULTROOTWINDOW DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (XDEFAULTROOTWINDOW* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTSCREENOFDISPLAY*
                ("XDefaultScreenOfDisplay" (IN REP/C-POINTER))
                REP/POINTER)
(DEFINE (XDEFAULTSCREENOFDISPLAY DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (CONS 'SCREENP
                                   (XDEFAULTSCREENOFDISPLAY* DPY))))
              RETURN-VALUE))
(DEFINE-FOREIGN XSCREENOFDISPLAY*
                ("XScreenOfDisplay" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/POINTER)
(DEFINE (XSCREENOFDISPLAY DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (CONS 'SCREENP (XSCREENOFDISPLAY* DPY SCR))))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTSCREEN*
                ("XDefaultScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XDEFAULTSCREEN DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XDEFAULTSCREEN* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTVISUAL*
                ("XDefaultVisual" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/POINTER)
(DEFINE (XDEFAULTVISUAL DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (CONS 'VISUALP (XDEFAULTVISUAL* DPY SCR))))
              RETURN-VALUE))
(DEFINE-FOREIGN XDISPLAYCELLS*
                ("XDisplayCells" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XDISPLAYCELLS DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XDISPLAYCELLS* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDISPLAYPLANES*
                ("XDisplayPlanes" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XDISPLAYPLANES DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XDISPLAYPLANES* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDISPLAYSTRING*
                ("XDisplayString" (IN REP/C-POINTER))
                REP/POINTER)
(DEFINE (XDISPLAYSTRING DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (ASCIZ->STRING (XDISPLAYSTRING* DPY))))
              RETURN-VALUE))
(DEFINE-FOREIGN XLASTKNOWNREQUESTPROCESSED*
                ("XLastKnownRequestProcessed" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XLASTKNOWNREQUESTPROCESSED DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (XLASTKNOWNREQUESTPROCESSED* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XNEXTREQUEST* ("XNextRequest" (IN REP/C-POINTER)) REP/INTEGER)
(DEFINE (XNEXTREQUEST DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XNEXTREQUEST* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XPROTOCOLVERSION*
                ("XProtocolVersion" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XPROTOCOLVERSION DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XPROTOCOLVERSION* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XPROTOCOLREVISION*
                ("XProtocolRevision" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XPROTOCOLREVISION DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XPROTOCOLREVISION* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XQLENGTH* ("XQLength" (IN REP/C-POINTER)) REP/INTEGER)
(DEFINE (XQLENGTH DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XQLENGTH* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XROOTWINDOW*
                ("XRootWindow" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XROOTWINDOW DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XROOTWINDOW* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XSCREENCOUNT* ("XScreenCount" (IN REP/C-POINTER)) REP/INTEGER)
(DEFINE (XSCREENCOUNT DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XSCREENCOUNT* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XSERVERVENDOR* ("XServerVendor" (IN REP/C-POINTER)) REP/POINTER)
(DEFINE (XSERVERVENDOR DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (ASCIZ->STRING (XSERVERVENDOR* DPY))))
              RETURN-VALUE))
(DEFINE-FOREIGN XVENDORRELEASE*
                ("XVendorRelease" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XVENDORRELEASE DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XVENDORRELEASE* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XIMAGEBYTEORDER*
                ("XImageByteOrder" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XIMAGEBYTEORDER DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XIMAGEBYTEORDER* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XBITMAPUNIT* ("XBitmapUnit" (IN REP/C-POINTER)) REP/INTEGER)
(DEFINE (XBITMAPUNIT DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XBITMAPUNIT* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XBITMAPBITORDER*
                ("XBitmapBitOrder" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XBITMAPBITORDER DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XBITMAPBITORDER* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XBITMAPPAD* ("XBitmapPad" (IN REP/C-POINTER)) REP/INTEGER)
(DEFINE (XBITMAPPAD DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY)) (RETURN-VALUE (XBITMAPPAD* DPY)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDISPLAYHEIGHT*
                ("XDisplayHeight" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XDISPLAYHEIGHT DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XDISPLAYHEIGHT* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDISPLAYHEIGHTMM*
                ("XDisplayHeightMM" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XDISPLAYHEIGHTMM DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XDISPLAYHEIGHTMM* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDISPLAYWIDTH*
                ("XDisplayWidth" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XDISPLAYWIDTH DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XDISPLAYWIDTH* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDISPLAYWIDTHMM*
                ("XDisplayWidthMM" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XDISPLAYWIDTHMM DPY SCR)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SCR SCR)
               (RETURN-VALUE (XDISPLAYWIDTHMM* DPY SCR)))
              RETURN-VALUE))
(DEFINE-FOREIGN XBLACKPIXELOFSCREEN*
                ("XBlackPixelOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XBLACKPIXELOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XBLACKPIXELOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XWHITEPIXELOFSCREEN*
                ("XWhitePixelOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XWHITEPIXELOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XWHITEPIXELOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XCELLSOFSCREEN*
                ("XCellsOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XCELLSOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XCELLSOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTCOLORMAPOFSCREEN*
                ("XDefaultColormapOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XDEFAULTCOLORMAPOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XDEFAULTCOLORMAPOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTDEPTHOFSCREEN*
                ("XDefaultDepthOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XDEFAULTDEPTHOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XDEFAULTDEPTHOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTGCOFSCREEN*
                ("XDefaultGCOfScreen" (IN REP/C-POINTER))
                REP/POINTER)
(DEFINE (XDEFAULTGCOFSCREEN S)
        (LET* ((S (CHK-SCREENP S))
               (RETURN-VALUE (CONS 'GC (XDEFAULTGCOFSCREEN* S))))
              RETURN-VALUE))
(DEFINE-FOREIGN XDEFAULTVISUALOFSCREEN*
                ("XDefaultVisualOfScreen" (IN REP/C-POINTER))
                REP/POINTER)
(DEFINE (XDEFAULTVISUALOFSCREEN S)
        (LET* ((S (CHK-SCREENP S))
               (RETURN-VALUE (CONS 'VISUALP (XDEFAULTVISUALOFSCREEN* S))))
              RETURN-VALUE))
(DEFINE-FOREIGN XDOESBACKINGSTORE*
                ("XDoesBackingStore" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XDOESBACKINGSTORE S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XDOESBACKINGSTORE* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDOESSAVEUNDERS*
                ("XDoesSaveUnders" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XDOESSAVEUNDERS S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XDOESSAVEUNDERS* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDISPLAYOFSCREEN*
                ("XDisplayOfScreen" (IN REP/C-POINTER))
                REP/POINTER)
(DEFINE (XDISPLAYOFSCREEN S)
        (LET* ((S (CHK-SCREENP S))
               (RETURN-VALUE (CONS 'DISPLAYP (XDISPLAYOFSCREEN* S))))
              RETURN-VALUE))
(DEFINE-FOREIGN XEVENTMASKOFSCREEN*
                ("XEventMaskOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XEVENTMASKOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XEVENTMASKOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XWIDTHOFSCREEN*
                ("XWidthOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XWIDTHOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XWIDTHOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XHEIGHTOFSCREEN*
                ("XHeightOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XHEIGHTOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XHEIGHTOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XWIDTHMMOFSCREEN*
                ("XWidthMMOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XWIDTHMMOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XWIDTHMMOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XHEIGHTMMOFSCREEN*
                ("XHeightMMOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XHEIGHTMMOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XHEIGHTMMOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XMAXCMAPSOFSCREEN*
                ("XMaxCmapsOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XMAXCMAPSOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XMAXCMAPSOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XMINCMAPSOFSCREEN*
                ("XMinCmapsOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XMINCMAPSOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XMINCMAPSOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XPLANESOFSCREEN*
                ("XPlanesOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XPLANESOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XPLANESOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XROOTWINDOWOFSCREEN*
                ("XRootWindowOfScreen" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XROOTWINDOWOFSCREEN S)
        (LET* ((S (CHK-SCREENP S)) (RETURN-VALUE (XROOTWINDOWOFSCREEN* S)))
              RETURN-VALUE))
(DEFINE-FOREIGN XNOOP* ("XNoOp" (IN REP/C-POINTER)) IGNORE)
(DEFINE (XNOOP DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XNOOP* DPY) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XFREE* ("XFree" (IN REP/INTEGER)) IGNORE)
(DEFINE (XFREE DATA)
        (LET* ((DATA DATA) (RETURN-VALUE (BLOCK (XFREE* DATA) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCLOSEDISPLAY* ("XCloseDisplay" (IN REP/C-POINTER)) IGNORE)
(DEFINE (XCLOSEDISPLAY DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XCLOSEDISPLAY* DPY) '())))
              RETURN-VALUE))
