(HERALD XWS4 (ENV TSYS (XLIB INTERFACE)))

(DEFINE-FOREIGN XQUERYTREE*
                ("XQueryTree" (IN REP/C-POINTER)
                              (IN REP/INTEGER)
                              (IN REP/EXTEND)
                              (IN REP/EXTEND)
                              (IN REP/EXTEND)
                              (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XQUERYTREE DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (ROOT (MAKE-BYTEV 4))
               (PARENT (MAKE-BYTEV 4))
               (CHILDREN (MAKE-BYTEV 4))
               (NCHILDREN (MAKE-BYTEV 4))
               (RETURN-VALUE (XQUERYTREE* DPY W ROOT PARENT CHILDREN NCHILDREN)))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER ROOT 0)
                      (MREF-INTEGER PARENT 0)
                      (CONS 'UNSIGNEDAP (MREF-POINTER CHILDREN 0))
                      (MREF-INTEGER NCHILDREN 0))))
(DEFINE-FOREIGN XGETWINDOWATTRIBUTES*
                ("XGetWindowAttributes" (IN REP/C-POINTER)
                                        (IN REP/INTEGER)
                                        (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XGETWINDOWATTRIBUTES DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (ATT (MAKE-BYTEV 92))
               (RETURN-VALUE (XGETWINDOWATTRIBUTES* DPY W ATT)))
              (RETURN RETURN-VALUE (CONS 'XWINDOWATTRIBUTESP ATT))))
(DEFINE-FOREIGN XGETGEOMETRY*
                ("XGetGeometry" (IN REP/C-POINTER)
                                (IN REP/INTEGER)
                                (IN REP/EXTEND)
                                (IN REP/EXTEND)
                                (IN REP/EXTEND)
                                (IN REP/EXTEND)
                                (IN REP/EXTEND)
                                (IN REP/EXTEND)
                                (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XGETGEOMETRY DPY D)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (D D)
               (ROOT (MAKE-BYTEV 4))
               (X (MAKE-BYTEV 4))
               (Y (MAKE-BYTEV 4))
               (WIDTH (MAKE-BYTEV 4))
               (HEIGHT (MAKE-BYTEV 4))
               (BORDERWIDTH (MAKE-BYTEV 4))
               (DEPTH (MAKE-BYTEV 4))
               (RETURN-VALUE (XGETGEOMETRY* DPY
                                            D
                                            ROOT
                                            X
                                            Y
                                            WIDTH
                                            HEIGHT
                                            BORDERWIDTH
                                            DEPTH)))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER ROOT 0)
                      (MREF-INTEGER X 0)
                      (MREF-INTEGER Y 0)
                      (MREF-INTEGER WIDTH 0)
                      (MREF-INTEGER HEIGHT 0)
                      (MREF-INTEGER BORDERWIDTH 0)
                      (MREF-INTEGER DEPTH 0))))
(DEFINE-FOREIGN XQUERYPOINTER*
                ("XQueryPointer" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/EXTEND)
                                 (IN REP/EXTEND)
                                 (IN REP/EXTEND)
                                 (IN REP/EXTEND)
                                 (IN REP/EXTEND)
                                 (IN REP/EXTEND)
                                 (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XQUERYPOINTER DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (ROOT (MAKE-BYTEV 4))
               (CHILD (MAKE-BYTEV 4))
               (ROOT_X (MAKE-BYTEV 4))
               (ROOT_Y (MAKE-BYTEV 4))
               (WIN_X (MAKE-BYTEV 4))
               (WIN_Y (MAKE-BYTEV 4))
               (MASK (MAKE-BYTEV 4))
               (RETURN-VALUE (XQUERYPOINTER* DPY
                                             W
                                             ROOT
                                             CHILD
                                             ROOT_X
                                             ROOT_Y
                                             WIN_X
                                             WIN_Y
                                             MASK)))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER ROOT 0)
                      (MREF-INTEGER CHILD 0)
                      (MREF-INTEGER ROOT_X 0)
                      (MREF-INTEGER ROOT_Y 0)
                      (MREF-INTEGER WIN_X 0)
                      (MREF-INTEGER WIN_Y 0)
                      (MREF-INTEGER MASK 0))))
(DEFINE-FOREIGN XINTERNATOM*
                ("XInternAtom" (IN REP/C-POINTER)
                               (IN REP/STRING)
                               (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XINTERNATOM DPY NAME ONLYIFEXISTS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (NAME (IF (STRING? NAME)
                         (STRING->ASCIZ! NAME)
                         (ERROR "Argument is incorrect type: ~s" NAME)))
               (ONLYIFEXISTS ONLYIFEXISTS)
               (RETURN-VALUE (XINTERNATOM* DPY NAME ONLYIFEXISTS)))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETATOMNAME*
                ("XGetAtomName" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/POINTER)
(DEFINE (XGETATOMNAME DPY ATOM)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (ATOM ATOM)
               (RETURN-VALUE (CONS 'CHARAP (XGETATOMNAME* DPY ATOM))))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETWINDOWPROPERTY*
                ("XGetWindowProperty" (IN REP/C-POINTER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER)
                                      (IN REP/EXTEND)
                                      (IN REP/EXTEND)
                                      (IN REP/EXTEND)
                                      (IN REP/EXTEND)
                                      (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XGETWINDOWPROPERTY DPY W PROPERTY OFFSET LENGTH DELETE REQ_TYPE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (PROPERTY PROPERTY)
               (OFFSET OFFSET)
               (LENGTH LENGTH)
               (DELETE DELETE)
               (REQ_TYPE REQ_TYPE)
               (ACTUAL_TYPE (MAKE-BYTEV 4))
               (ACTUAL_FORMAT (MAKE-BYTEV 4))
               (NITEMS (MAKE-BYTEV 4))
               (BYTESAFTER (MAKE-BYTEV 4))
               (PROP (MAKE-BYTEV 4))
               (RETURN-VALUE (XGETWINDOWPROPERTY* DPY
                                                  W
                                                  PROPERTY
                                                  OFFSET
                                                  LENGTH
                                                  DELETE
                                                  REQ_TYPE
                                                  ACTUAL_TYPE
                                                  ACTUAL_FORMAT
                                                  NITEMS
                                                  BYTESAFTER
                                                  PROP)))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER ACTUAL_TYPE 0)
                      (MREF-INTEGER ACTUAL_FORMAT 0)
                      (MREF-INTEGER NITEMS 0)
                      (MREF-INTEGER BYTESAFTER 0)
                      (CONS 'CHARAP (MREF-POINTER PROP 0)))))
(DEFINE-FOREIGN XLISTPROPERTIES*
                ("XListProperties" (IN REP/C-POINTER)
                                   (IN REP/INTEGER)
                                   (IN REP/EXTEND))
                REP/POINTER)
(DEFINE (XLISTPROPERTIES DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (NUM_PROP (MAKE-BYTEV 4))
               (RETURN-VALUE (CONS 'UNSIGNEDAP
                                   (XLISTPROPERTIES* DPY W NUM_PROP))))
              (RETURN RETURN-VALUE (MREF-INTEGER NUM_PROP 0))))
(DEFINE-FOREIGN XCHANGEPROPERTY*
                ("XChangeProperty" (IN REP/C-POINTER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER)
                                   (IN REP/C-POINTER)
                                   (IN REP/INTEGER))
                IGNORE)
(DEFINE (XCHANGEPROPERTY DPY W PROPERTY TYPE FORMAT MODE DATA NELEMENTS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (PROPERTY PROPERTY)
               (TYPE TYPE)
               (FORMAT FORMAT)
               (MODE MODE)
               (DATA (CHK-CHARAP DATA))
               (NELEMENTS NELEMENTS)
               (RETURN-VALUE (BLOCK (XCHANGEPROPERTY* DPY
                                                      W
                                                      PROPERTY
                                                      TYPE
                                                      FORMAT
                                                      MODE
                                                      DATA
                                                      NELEMENTS)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XROTATEWINDOWPROPERTIES*
                ("XRotateWindowProperties" (IN REP/C-POINTER)
                                           (IN REP/INTEGER)
                                           (IN REP/C-POINTER)
                                           (IN REP/INTEGER)
                                           (IN REP/INTEGER))
                IGNORE)
(DEFINE (XROTATEWINDOWPROPERTIES DPY W PROPERTIES NPROPS NPOSITIONS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (PROPERTIES (CHK-UNSIGNEDAP PROPERTIES))
               (NPROPS NPROPS)
               (NPOSITIONS NPOSITIONS)
               (RETURN-VALUE (BLOCK (XROTATEWINDOWPROPERTIES* DPY
                                                              W
                                                              PROPERTIES
                                                              NPROPS
                                                              NPOSITIONS)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XDELETEPROPERTY*
                ("XDeleteProperty" (IN REP/C-POINTER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER))
                IGNORE)
(DEFINE (XDELETEPROPERTY DPY WINDOW PROPERTY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (WINDOW WINDOW)
               (PROPERTY PROPERTY)
               (RETURN-VALUE (BLOCK (XDELETEPROPERTY* DPY WINDOW PROPERTY)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETSELECTIONOWNER*
                ("XSetSelectionOwner" (IN REP/C-POINTER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETSELECTIONOWNER DPY SELECTION OWNER TIME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SELECTION SELECTION)
               (OWNER OWNER)
               (TIME TIME)
               (RETURN-VALUE (BLOCK (XSETSELECTIONOWNER* DPY
                                                         SELECTION
                                                         OWNER
                                                         TIME)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETSELECTIONOWNER*
                ("XGetSelectionOwner" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XGETSELECTIONOWNER DPY SELECTION)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SELECTION SELECTION)
               (RETURN-VALUE (XGETSELECTIONOWNER* DPY SELECTION)))
              RETURN-VALUE))
(DEFINE-FOREIGN XCONVERTSELECTION*
                ("XConvertSelection" (IN REP/C-POINTER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER))
                IGNORE)
(DEFINE (XCONVERTSELECTION DPY SELECTION TARGET PROPERTY REQUESTOR TIME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SELECTION SELECTION)
               (TARGET TARGET)
               (PROPERTY PROPERTY)
               (REQUESTOR REQUESTOR)
               (TIME TIME)
               (RETURN-VALUE (BLOCK (XCONVERTSELECTION* DPY
                                                        SELECTION
                                                        TARGET
                                                        PROPERTY
                                                        REQUESTOR
                                                        TIME)
                                    '())))
              RETURN-VALUE))
