(HERALD XWS5 (ENV TSYS (XLIB INTERFACE)))

(DEFINE-FOREIGN XCREATECOLORMAP*
                ("XCreateColormap" (IN REP/C-POINTER)
                                   (IN REP/INTEGER)
                                   (IN REP/C-POINTER)
                                   (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XCREATECOLORMAP DPY W VISUAL ALLOC)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (VISUAL (CHK-VISUALP VISUAL))
               (ALLOC ALLOC)
               (RETURN-VALUE (XCREATECOLORMAP* DPY W VISUAL ALLOC)))
              RETURN-VALUE))
(DEFINE-FOREIGN XCOPYCOLORMAPANDFREE*
                ("XCopyColormapAndFree" (IN REP/C-POINTER) (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XCOPYCOLORMAPANDFREE DPY SRC_CMAP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SRC_CMAP SRC_CMAP)
               (RETURN-VALUE (XCOPYCOLORMAPANDFREE* DPY SRC_CMAP)))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETWINDOWCOLORMAP*
                ("XSetWindowColormap" (IN REP/C-POINTER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETWINDOWCOLORMAP DPY W COLORMAP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (COLORMAP COLORMAP)
               (RETURN-VALUE (BLOCK (XSETWINDOWCOLORMAP* DPY W COLORMAP)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XFREECOLORMAP*
                ("XFreeColormap" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XFREECOLORMAP DPY CMAP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (RETURN-VALUE (BLOCK (XFREECOLORMAP* DPY CMAP) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XALLOCCOLOR*
                ("XAllocColor" (IN REP/C-POINTER)
                               (IN REP/INTEGER)
                               (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XALLOCCOLOR DPY CMAP DEF)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (DEF (CHK-XCOLORP DEF))
               (RETURN-VALUE (XALLOCCOLOR* DPY CMAP DEF)))
              RETURN-VALUE))
(DEFINE-FOREIGN XALLOCNAMEDCOLOR*
                ("XAllocNamedColor" (IN REP/C-POINTER)
                                    (IN REP/INTEGER)
                                    (IN REP/STRING)
                                    (IN REP/EXTEND)
                                    (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XALLOCNAMEDCOLOR DPY CMAP COLORNAME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (COLORNAME (IF (STRING? COLORNAME)
                              (STRING->ASCIZ! COLORNAME)
                              (ERROR "Argument is incorrect type: ~s" COLORNAME)))
               (HARD_DEF (MAKE-BYTEV 12))
               (EXACT_DEF (MAKE-BYTEV 12))
               (RETURN-VALUE (XALLOCNAMEDCOLOR* DPY
                                                CMAP
                                                COLORNAME
                                                HARD_DEF
                                                EXACT_DEF)))
              (RETURN RETURN-VALUE
                      (CONS 'XCOLORP HARD_DEF)
                      (CONS 'XCOLORP EXACT_DEF))))
(DEFINE-FOREIGN XLOOKUPCOLOR*
                ("XLookupColor" (IN REP/C-POINTER)
                                (IN REP/INTEGER)
                                (IN REP/STRING)
                                (IN REP/EXTEND)
                                (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XLOOKUPCOLOR DPY CMAP SPEC)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (SPEC (IF (STRING? SPEC)
                         (STRING->ASCIZ! SPEC)
                         (ERROR "Argument is incorrect type: ~s" SPEC)))
               (DEF (MAKE-BYTEV 12))
               (SCR (MAKE-BYTEV 12))
               (RETURN-VALUE (XLOOKUPCOLOR* DPY CMAP SPEC DEF SCR)))
              (RETURN RETURN-VALUE
                      (CONS 'XCOLORP DEF)
                      (CONS 'XCOLORP SCR))))
(DEFINE-FOREIGN XALLOCCOLORCELLS*
                ("XAllocColorCells" (IN REP/C-POINTER)
                                    (IN REP/INTEGER)
                                    (IN REP/INTEGER)
                                    (IN REP/C-POINTER)
                                    (IN REP/INTEGER)
                                    (IN REP/C-POINTER)
                                    (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XALLOCCOLORCELLS DPY CMAP CONTIG MASKS NPLANES PIXELS NCOLORS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (CONTIG CONTIG)
               (MASKS (CHK-UNSIGNEDAP MASKS))
               (NPLANES NPLANES)
               (PIXELS (CHK-UNSIGNEDAP PIXELS))
               (NCOLORS NCOLORS)
               (RETURN-VALUE (XALLOCCOLORCELLS* DPY
                                                CMAP
                                                CONTIG
                                                MASKS
                                                NPLANES
                                                PIXELS
                                                NCOLORS)))
              RETURN-VALUE))
(DEFINE-FOREIGN XALLOCCOLORPLANES*
                ("XAllocColorPlanes" (IN REP/C-POINTER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/C-POINTER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/EXTEND)
                                     (IN REP/EXTEND)
                                     (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XALLOCCOLORPLANES DPY CMAP CONTIG PIXELS NCOLORS NREDS NGREENS NBLUES)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (CONTIG CONTIG)
               (PIXELS (CHK-UNSIGNEDAP PIXELS))
               (NCOLORS NCOLORS)
               (NREDS NREDS)
               (NGREENS NGREENS)
               (NBLUES NBLUES)
               (RMASK (MAKE-BYTEV 4))
               (GMASK (MAKE-BYTEV 4))
               (BMASK (MAKE-BYTEV 4))
               (RETURN-VALUE (XALLOCCOLORPLANES* DPY
                                                 CMAP
                                                 CONTIG
                                                 PIXELS
                                                 NCOLORS
                                                 NREDS
                                                 NGREENS
                                                 NBLUES
                                                 RMASK
                                                 GMASK
                                                 BMASK)))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER RMASK 0)
                      (MREF-INTEGER GMASK 0)
                      (MREF-INTEGER BMASK 0))))
(DEFINE-FOREIGN XSTORECOLORS*
                ("XStoreColors" (IN REP/C-POINTER)
                                (IN REP/INTEGER)
                                (IN REP/C-POINTER)
                                (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSTORECOLORS DPY CMAP DEFS NCOLORS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (DEFS (CHK-XCOLORAP DEFS))
               (NCOLORS NCOLORS)
               (RETURN-VALUE (BLOCK (XSTORECOLORS* DPY CMAP DEFS NCOLORS)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSTORECOLOR*
                ("XStoreColor" (IN REP/C-POINTER)
                               (IN REP/INTEGER)
                               (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XSTORECOLOR DPY CMAP DEF)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (DEF (CHK-XCOLORP DEF))
               (RETURN-VALUE (BLOCK (XSTORECOLOR* DPY CMAP DEF) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSTORENAMEDCOLOR*
                ("XStoreNamedColor" (IN REP/C-POINTER)
                                    (IN REP/INTEGER)
                                    (IN REP/STRING)
                                    (IN REP/INTEGER)
                                    (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSTORENAMEDCOLOR DPY CMAP NAME PIXEL FLAGS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (NAME (IF (STRING? NAME)
                         (STRING->ASCIZ! NAME)
                         (ERROR "Argument is incorrect type: ~s" NAME)))
               (PIXEL PIXEL)
               (FLAGS FLAGS)
               (RETURN-VALUE (BLOCK (XSTORENAMEDCOLOR* DPY
                                                       CMAP
                                                       NAME
                                                       PIXEL
                                                       FLAGS)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XFREECOLORS*
                ("XFreeColors" (IN REP/C-POINTER)
                               (IN REP/INTEGER)
                               (IN REP/C-POINTER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER))
                IGNORE)
(DEFINE (XFREECOLORS DPY CMAP PIXELS NPIXELS PLANES)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (PIXELS (CHK-UNSIGNEDAP PIXELS))
               (NPIXELS NPIXELS)
               (PLANES PLANES)
               (RETURN-VALUE (BLOCK (XFREECOLORS* DPY
                                                  CMAP
                                                  PIXELS
                                                  NPIXELS
                                                  PLANES)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XQUERYCOLOR*
                ("XQueryColor" (IN REP/C-POINTER)
                               (IN REP/INTEGER)
                               (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XQUERYCOLOR DPY CMAP DEF)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (DEF (CHK-XCOLORP DEF))
               (RETURN-VALUE (BLOCK (XQUERYCOLOR* DPY CMAP DEF) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XQUERYCOLORS*
                ("XQueryColors" (IN REP/C-POINTER)
                                (IN REP/INTEGER)
                                (IN REP/C-POINTER)
                                (IN REP/INTEGER))
                IGNORE)
(DEFINE (XQUERYCOLORS DPY CMAP DEFS NCOLORS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (DEFS (CHK-XCOLORAP DEFS))
               (NCOLORS NCOLORS)
               (RETURN-VALUE (BLOCK (XQUERYCOLORS* DPY CMAP DEFS NCOLORS)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCREATEPIXMAP*
                ("XCreatePixmap" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XCREATEPIXMAP DPY D WIDTH HEIGHT DEPTH)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (D D)
               (WIDTH WIDTH)
               (HEIGHT HEIGHT)
               (DEPTH DEPTH)
               (RETURN-VALUE (XCREATEPIXMAP* DPY D WIDTH HEIGHT DEPTH)))
              RETURN-VALUE))
(DEFINE-FOREIGN XFREEPIXMAP*
                ("XFreePixmap" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XFREEPIXMAP DPY PIXMAP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (PIXMAP PIXMAP)
               (RETURN-VALUE (BLOCK (XFREEPIXMAP* DPY PIXMAP) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCREATEGC*
                ("XCreateGC" (IN REP/C-POINTER)
                             (IN REP/INTEGER)
                             (IN REP/INTEGER)
                             (IN REP/C-POINTER))
                REP/POINTER)
(DEFINE (XCREATEGC DPY D VALUEMASK VALUES)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (D D)
               (VALUEMASK VALUEMASK)
               (VALUES (CHK-XGCVALUESP VALUES))
               (RETURN-VALUE (CONS 'GC
                                   (XCREATEGC* DPY D VALUEMASK VALUES))))
              RETURN-VALUE))
(DEFINE-FOREIGN XCOPYGC*
                ("XCopyGC" (IN REP/C-POINTER)
                           (IN REP/C-POINTER)
                           (IN REP/INTEGER)
                           (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XCOPYGC DPY SRCGC MASK DESTGC)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SRCGC (CHK-GC SRCGC))
               (MASK MASK)
               (DESTGC (CHK-GC DESTGC))
               (RETURN-VALUE (BLOCK (XCOPYGC* DPY SRCGC MASK DESTGC) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCHANGEGC*
                ("XChangeGC" (IN REP/C-POINTER)
                             (IN REP/C-POINTER)
                             (IN REP/INTEGER)
                             (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XCHANGEGC DPY GC VALUEMASK VALUES)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (VALUEMASK VALUEMASK)
               (VALUES (CHK-XGCVALUESP VALUES))
               (RETURN-VALUE (BLOCK (XCHANGEGC* DPY GC VALUEMASK VALUES)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XFREEGC*
                ("XFreeGC" (IN REP/C-POINTER) (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XFREEGC DPY GC)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (RETURN-VALUE (BLOCK (XFREEGC* DPY GC) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGCONTEXTFROMGC*
                ("XGContextFromGC" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XGCONTEXTFROMGC GC)
        (LET* ((GC (CHK-GC GC)) (RETURN-VALUE (XGCONTEXTFROMGC* GC)))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETSTATE*
                ("XSetState" (IN REP/C-POINTER)
                             (IN REP/C-POINTER)
                             (IN REP/INTEGER)
                             (IN REP/INTEGER)
                             (IN REP/INTEGER)
                             (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETSTATE DPY GC FOREGROUND BACKGROUND FUNCTION PLANEMASK)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (FOREGROUND FOREGROUND)
               (BACKGROUND BACKGROUND)
               (FUNCTION FUNCTION)
               (PLANEMASK PLANEMASK)
               (RETURN-VALUE (BLOCK (XSETSTATE* DPY
                                                GC
                                                FOREGROUND
                                                BACKGROUND
                                                FUNCTION
                                                PLANEMASK)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETFOREGROUND*
                ("XSetForeground" (IN REP/C-POINTER)
                                  (IN REP/C-POINTER)
                                  (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETFOREGROUND DPY GC FOREGROUND)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (FOREGROUND FOREGROUND)
               (RETURN-VALUE (BLOCK (XSETFOREGROUND* DPY GC FOREGROUND)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETBACKGROUND*
                ("XSetBackground" (IN REP/C-POINTER)
                                  (IN REP/C-POINTER)
                                  (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETBACKGROUND DPY GC BACKGROUND)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (BACKGROUND BACKGROUND)
               (RETURN-VALUE (BLOCK (XSETBACKGROUND* DPY GC BACKGROUND)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETFUNCTION*
                ("XSetFunction" (IN REP/C-POINTER)
                                (IN REP/C-POINTER)
                                (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETFUNCTION DPY GC FUNCTION)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (FUNCTION FUNCTION)
               (RETURN-VALUE (BLOCK (XSETFUNCTION* DPY GC FUNCTION) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETPLANEMASK*
                ("XSetPlaneMask" (IN REP/C-POINTER)
                                 (IN REP/C-POINTER)
                                 (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETPLANEMASK DPY GC PLANEMASK)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (PLANEMASK PLANEMASK)
               (RETURN-VALUE (BLOCK (XSETPLANEMASK* DPY GC PLANEMASK)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETLINEATTRIBUTES*
                ("XSetLineAttributes" (IN REP/C-POINTER)
                                      (IN REP/C-POINTER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETLINEATTRIBUTES DPY GC LINEWIDTH LINESTYLE CAPSTYLE JOINSTYLE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (LINEWIDTH LINEWIDTH)
               (LINESTYLE LINESTYLE)
               (CAPSTYLE CAPSTYLE)
               (JOINSTYLE JOINSTYLE)
               (RETURN-VALUE (BLOCK (XSETLINEATTRIBUTES* DPY
                                                         GC
                                                         LINEWIDTH
                                                         LINESTYLE
                                                         CAPSTYLE
                                                         JOINSTYLE)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETDASHES*
                ("XSetDashes" (IN REP/C-POINTER)
                              (IN REP/C-POINTER)
                              (IN REP/INTEGER)
                              (IN REP/C-POINTER)
                              (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETDASHES DPY GC DASH_OFFSET LIST N)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (DASH_OFFSET DASH_OFFSET)
               (LIST (CHK-CHARAP LIST))
               (N N)
               (RETURN-VALUE (BLOCK (XSETDASHES* DPY GC DASH_OFFSET LIST N)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETFILLSTYLE*
                ("XSetFillStyle" (IN REP/C-POINTER)
                                 (IN REP/C-POINTER)
                                 (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETFILLSTYLE DPY GC FILL_STYLE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (FILL_STYLE FILL_STYLE)
               (RETURN-VALUE (BLOCK (XSETFILLSTYLE* DPY GC FILL_STYLE)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETFILLRULE*
                ("XSetFillRule" (IN REP/C-POINTER)
                                (IN REP/C-POINTER)
                                (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETFILLRULE DPY GC FILL_RULE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (FILL_RULE FILL_RULE)
               (RETURN-VALUE (BLOCK (XSETFILLRULE* DPY GC FILL_RULE) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XQUERYBESTSIZE*
                ("XQueryBestSize" (IN REP/C-POINTER)
                                  (IN REP/INTEGER)
                                  (IN REP/INTEGER)
                                  (IN REP/INTEGER)
                                  (IN REP/INTEGER)
                                  (IN REP/EXTEND)
                                  (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XQUERYBESTSIZE DPY CLASS DRAWABLE WIDTH HEIGHT)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CLASS CLASS)
               (DRAWABLE DRAWABLE)
               (WIDTH WIDTH)
               (HEIGHT HEIGHT)
               (RET_WIDTH (MAKE-BYTEV 4))
               (RET_HEIGHT (MAKE-BYTEV 4))
               (RETURN-VALUE (XQUERYBESTSIZE* DPY
                                              CLASS
                                              DRAWABLE
                                              WIDTH
                                              HEIGHT
                                              RET_WIDTH
                                              RET_HEIGHT)))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER RET_WIDTH 0)
                      (MREF-INTEGER RET_HEIGHT 0))))
(DEFINE-FOREIGN XQUERYBESTTILE*
                ("XQueryBestTile" (IN REP/C-POINTER)
                                  (IN REP/INTEGER)
                                  (IN REP/INTEGER)
                                  (IN REP/INTEGER)
                                  (IN REP/EXTEND)
                                  (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XQUERYBESTTILE DPY DRAWABLE WIDTH HEIGHT)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (DRAWABLE DRAWABLE)
               (WIDTH WIDTH)
               (HEIGHT HEIGHT)
               (RET_WIDTH (MAKE-BYTEV 4))
               (RET_HEIGHT (MAKE-BYTEV 4))
               (RETURN-VALUE (XQUERYBESTTILE* DPY
                                              DRAWABLE
                                              WIDTH
                                              HEIGHT
                                              RET_WIDTH
                                              RET_HEIGHT)))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER RET_WIDTH 0)
                      (MREF-INTEGER RET_HEIGHT 0))))
(DEFINE-FOREIGN XQUERYBESTSTIPPLE*
                ("XQueryBestStipple" (IN REP/C-POINTER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/EXTEND)
                                     (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XQUERYBESTSTIPPLE DPY DRAWABLE WIDTH HEIGHT)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (DRAWABLE DRAWABLE)
               (WIDTH WIDTH)
               (HEIGHT HEIGHT)
               (RET_WIDTH (MAKE-BYTEV 4))
               (RET_HEIGHT (MAKE-BYTEV 4))
               (RETURN-VALUE (XQUERYBESTSTIPPLE* DPY
                                                 DRAWABLE
                                                 WIDTH
                                                 HEIGHT
                                                 RET_WIDTH
                                                 RET_HEIGHT)))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER RET_WIDTH 0)
                      (MREF-INTEGER RET_HEIGHT 0))))
(DEFINE-FOREIGN XSETTILE*
                ("XSetTile" (IN REP/C-POINTER)
                            (IN REP/C-POINTER)
                            (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETTILE DPY GC TILE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (TILE TILE)
               (RETURN-VALUE (BLOCK (XSETTILE* DPY GC TILE) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETSTIPPLE*
                ("XSetStipple" (IN REP/C-POINTER)
                               (IN REP/C-POINTER)
                               (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETSTIPPLE DPY GC STIPPLE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (STIPPLE STIPPLE)
               (RETURN-VALUE (BLOCK (XSETSTIPPLE* DPY GC STIPPLE) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETTSORIGIN*
                ("XSetTSOrigin" (IN REP/C-POINTER)
                                (IN REP/C-POINTER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETTSORIGIN DPY GC X Y)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (X X)
               (Y Y)
               (RETURN-VALUE (BLOCK (XSETTSORIGIN* DPY GC X Y) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETFONT*
                ("XSetFont" (IN REP/C-POINTER)
                            (IN REP/C-POINTER)
                            (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETFONT DPY GC FONT)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (FONT FONT)
               (RETURN-VALUE (BLOCK (XSETFONT* DPY GC FONT) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETCLIPORIGIN*
                ("XSetClipOrigin" (IN REP/C-POINTER)
                                  (IN REP/C-POINTER)
                                  (IN REP/INTEGER)
                                  (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETCLIPORIGIN DPY GC XORIG YORIG)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (XORIG XORIG)
               (YORIG YORIG)
               (RETURN-VALUE (BLOCK (XSETCLIPORIGIN* DPY GC XORIG YORIG)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETCLIPMASK*
                ("XSetClipMask" (IN REP/C-POINTER)
                                (IN REP/C-POINTER)
                                (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETCLIPMASK DPY GC MASK)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (MASK MASK)
               (RETURN-VALUE (BLOCK (XSETCLIPMASK* DPY GC MASK) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETCLIPRECTANGLES*
                ("XSetClipRectangles" (IN REP/C-POINTER)
                                      (IN REP/C-POINTER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER)
                                      (IN REP/C-POINTER)
                                      (IN REP/INTEGER)
                                      (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETCLIPRECTANGLES DPY
                            GC
                            CLIP_X_ORIGIN
                            CLIP_Y_ORIGIN
                            RECTANGLES
                            N
                            ORDERING)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (CLIP_X_ORIGIN CLIP_X_ORIGIN)
               (CLIP_Y_ORIGIN CLIP_Y_ORIGIN)
               (RECTANGLES (CHK-XRECTANGLEAP RECTANGLES))
               (N N)
               (ORDERING ORDERING)
               (RETURN-VALUE (BLOCK (XSETCLIPRECTANGLES* DPY
                                                         GC
                                                         CLIP_X_ORIGIN
                                                         CLIP_Y_ORIGIN
                                                         RECTANGLES
                                                         N
                                                         ORDERING)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETARCMODE*
                ("XSetArcMode" (IN REP/C-POINTER)
                               (IN REP/C-POINTER)
                               (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETARCMODE DPY GC ARC_MODE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (ARC_MODE ARC_MODE)
               (RETURN-VALUE (BLOCK (XSETARCMODE* DPY GC ARC_MODE) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETSUBWINDOWMODE*
                ("XSetSubwindowMode" (IN REP/C-POINTER)
                                     (IN REP/C-POINTER)
                                     (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETSUBWINDOWMODE DPY GC SUBWINDOW_MODE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (SUBWINDOW_MODE SUBWINDOW_MODE)
               (RETURN-VALUE (BLOCK (XSETSUBWINDOWMODE* DPY GC SUBWINDOW_MODE)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETGRAPHICSEXPOSURES*
                ("XSetGraphicsExposures" (IN REP/C-POINTER)
                                         (IN REP/C-POINTER)
                                         (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETGRAPHICSEXPOSURES DPY GC GRAPHICS_EXPOSURES)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GC (CHK-GC GC))
               (GRAPHICS_EXPOSURES GRAPHICS_EXPOSURES)
               (RETURN-VALUE (BLOCK (XSETGRAPHICSEXPOSURES* DPY
                                                            GC
                                                            GRAPHICS_EXPOSURES)
                                    '())))
              RETURN-VALUE))
