(HERALD XWS9 (ENV TSYS (XLIB INTERFACE)))

(DEFINE-FOREIGN XSTORENAME*
                ("XStoreName" (IN REP/C-POINTER)
                              (IN REP/INTEGER)
                              (IN REP/STRING))
                IGNORE)
(DEFINE (XSTORENAME DPY W NAME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (NAME (IF (STRING? NAME)
                         (STRING->ASCIZ! NAME)
                         (ERROR "Argument is incorrect type: ~s" NAME)))
               (RETURN-VALUE (BLOCK (XSTORENAME* DPY W NAME) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETICONNAME*
                ("XSetIconName" (IN REP/C-POINTER)
                                (IN REP/INTEGER)
                                (IN REP/STRING))
                IGNORE)
(DEFINE (XSETICONNAME DPY W ICON_NAME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (ICON_NAME (IF (STRING? ICON_NAME)
                              (STRING->ASCIZ! ICON_NAME)
                              (ERROR "Argument is incorrect type: ~s" ICON_NAME)))
               (RETURN-VALUE (BLOCK (XSETICONNAME* DPY W ICON_NAME) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETWMHINTS*
                ("XSetWMHints" (IN REP/C-POINTER)
                               (IN REP/INTEGER)
                               (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XSETWMHINTS DPY W HINTS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (HINTS (CHK-XWMHINTSP HINTS))
               (RETURN-VALUE (BLOCK (XSETWMHINTS* DPY W HINTS) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETNORMALHINTS*
                ("XSetNormalHints" (IN REP/C-POINTER)
                                   (IN REP/INTEGER)
                                   (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XSETNORMALHINTS DPY W HINTS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (HINTS (CHK-XSIZEHINTSP HINTS))
               (RETURN-VALUE (BLOCK (XSETNORMALHINTS* DPY W HINTS) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETNORMALHINTS*
                ("XGetNormalHints" (IN REP/C-POINTER)
                                   (IN REP/INTEGER)
                                   (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XGETNORMALHINTS DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (HINTS (MAKE-BYTEV 60))
               (RETURN-VALUE (XGETNORMALHINTS* DPY W HINTS)))
              (RETURN RETURN-VALUE (CONS 'XSIZEHINTSP HINTS))))
(DEFINE-FOREIGN XSETZOOMHINTS*
                ("XSetZoomHints" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XSETZOOMHINTS DPY W ZHINTS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (ZHINTS (CHK-XSIZEHINTSP ZHINTS))
               (RETURN-VALUE (BLOCK (XSETZOOMHINTS* DPY W ZHINTS) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETZOOMHINTS*
                ("XGetZoomHints" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XGETZOOMHINTS DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (ZHINTS (MAKE-BYTEV 60))
               (RETURN-VALUE (XGETZOOMHINTS* DPY W ZHINTS)))
              (RETURN RETURN-VALUE (CONS 'XSIZEHINTSP ZHINTS))))
(DEFINE-FOREIGN XSETSIZEHINTS*
                ("XSetSizeHints" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/C-POINTER)
                                 (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETSIZEHINTS DPY W HINTS PROPERTY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (HINTS (CHK-XSIZEHINTSP HINTS))
               (PROPERTY PROPERTY)
               (RETURN-VALUE (BLOCK (XSETSIZEHINTS* DPY W HINTS PROPERTY)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETSIZEHINTS*
                ("XGetSizeHints" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/EXTEND)
                                 (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XGETSIZEHINTS DPY W PROPERTY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (HINTS (MAKE-BYTEV 60))
               (PROPERTY PROPERTY)
               (RETURN-VALUE (XGETSIZEHINTS* DPY W HINTS PROPERTY)))
              (RETURN RETURN-VALUE (CONS 'XSIZEHINTSP HINTS))))
(DEFINE-FOREIGN XSETTRANSIENTFORHINT*
                ("XSetTransientForHint" (IN REP/C-POINTER)
                                        (IN REP/INTEGER)
                                        (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETTRANSIENTFORHINT DPY W PROPWINDOW)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (PROPWINDOW PROPWINDOW)
               (RETURN-VALUE (BLOCK (XSETTRANSIENTFORHINT* DPY W PROPWINDOW)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETTRANSIENTFORHINT*
                ("XGetTransientForHint" (IN REP/C-POINTER)
                                        (IN REP/INTEGER)
                                        (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XGETTRANSIENTFORHINT DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (PROPWINDOW (MAKE-BYTEV 4))
               (RETURN-VALUE (XGETTRANSIENTFORHINT* DPY W PROPWINDOW)))
              (RETURN RETURN-VALUE (MREF-INTEGER PROPWINDOW 0))))
(DEFINE-FOREIGN XGETSTANDARDCOLORMAP*
                ("XGetStandardColormap" (IN REP/C-POINTER)
                                        (IN REP/INTEGER)
                                        (IN REP/EXTEND)
                                        (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XGETSTANDARDCOLORMAP DPY W PROPERTY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (CMAP (MAKE-BYTEV 32))
               (PROPERTY PROPERTY)
               (RETURN-VALUE (XGETSTANDARDCOLORMAP* DPY W CMAP PROPERTY)))
              (RETURN RETURN-VALUE (CONS 'XSTANDARDCOLORMAPP CMAP))))
(DEFINE-FOREIGN XSETSTANDARDCOLORMAP*
                ("XSetStandardColormap" (IN REP/C-POINTER)
                                        (IN REP/INTEGER)
                                        (IN REP/C-POINTER)
                                        (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETSTANDARDCOLORMAP DPY W CMAP PROPERTY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (CMAP (CHK-XSTANDARDCOLORMAPP CMAP))
               (PROPERTY PROPERTY)
               (RETURN-VALUE (BLOCK (XSETSTANDARDCOLORMAP* DPY W CMAP PROPERTY)
                                    '())))
              RETURN-VALUE))
