(herald ximage (env tsys (xlib interface)))
(DEFINE (MAKE-XIMAGE) (CONS 'XIMAGEP (MAKE-BYTEV 88)))
(DEFINE (XIMAGE-WIDTH X) (MREF-INTEGER (CHK-XIMAGEP X) 0))
(DEFINE (XIMAGE-WIDTH! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 0 Y))
(DEFINE (XIMAGE-HEIGHT X) (MREF-INTEGER (CHK-XIMAGEP X) 4))
(DEFINE (XIMAGE-HEIGHT! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 4 Y))
(DEFINE (XIMAGE-XOFFSET X) (MREF-INTEGER (CHK-XIMAGEP X) 8))
(DEFINE (XIMAGE-XOFFSET! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 8 Y))
(DEFINE (XIMAGE-FORMAT X) (MREF-INTEGER (CHK-XIMAGEP X) 12))
(DEFINE (XIMAGE-FORMAT! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 12 Y))
(DEFINE (XIMAGE-DATA X)
        ((LAMBDA (X Y) (CONS 'CHARAP (MREF-POINTER X Y)))
         (CHK-XIMAGEP X)
         16))
(DEFINE (XIMAGE-DATA! X Y)
        ((LAMBDA (X Y Z) (SET-MREF-POINTER! X Y (CHK-CHARAP Z)))
         (CHK-XIMAGEP X)
         16
         Y))
(DEFINE (XIMAGE-BYTE_ORDER X) (MREF-INTEGER (CHK-XIMAGEP X) 20))
(DEFINE (XIMAGE-BYTE_ORDER! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 20 Y))
(DEFINE (XIMAGE-BITMAP_UNIT X) (MREF-INTEGER (CHK-XIMAGEP X) 24))
(DEFINE (XIMAGE-BITMAP_UNIT! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 24 Y))
(DEFINE (XIMAGE-BITMAP_BIT_ORDER X) (MREF-INTEGER (CHK-XIMAGEP X) 28))
(DEFINE (XIMAGE-BITMAP_BIT_ORDER! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 28 Y))
(DEFINE (XIMAGE-BITMAP_PAD X) (MREF-INTEGER (CHK-XIMAGEP X) 32))
(DEFINE (XIMAGE-BITMAP_PAD! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 32 Y))
(DEFINE (XIMAGE-DEPTH X) (MREF-INTEGER (CHK-XIMAGEP X) 36))
(DEFINE (XIMAGE-DEPTH! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 36 Y))
(DEFINE (XIMAGE-BYTES_PER_LINE X) (MREF-INTEGER (CHK-XIMAGEP X) 40))
(DEFINE (XIMAGE-BYTES_PER_LINE! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 40 Y))
(DEFINE (XIMAGE-BITS_PER_PIXEL X) (MREF-INTEGER (CHK-XIMAGEP X) 44))
(DEFINE (XIMAGE-BITS_PER_PIXEL! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 44 Y))
(DEFINE (XIMAGE-RED_MASK X) (MREF-INTEGER (CHK-XIMAGEP X) 48))
(DEFINE (XIMAGE-RED_MASK! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 48 Y))
(DEFINE (XIMAGE-GREEN_MASK X) (MREF-INTEGER (CHK-XIMAGEP X) 52))
(DEFINE (XIMAGE-GREEN_MASK! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 52 Y))
(DEFINE (XIMAGE-BLUE_MASK X) (MREF-INTEGER (CHK-XIMAGEP X) 56))
(DEFINE (XIMAGE-BLUE_MASK! X Y) (SET-MREF-INTEGER! (CHK-XIMAGEP X) 56 Y))
(DEFINE (XIMAGE-OBDATA X)
        ((LAMBDA (X Y) (CONS 'CHARP (MREF-POINTER X Y)))
         (CHK-XIMAGEP X)
         60))
(DEFINE (XIMAGE-OBDATA! X Y)
        ((LAMBDA (X Y Z) (SET-MREF-POINTER! X Y (CHK-CHARP Z)))
         (CHK-XIMAGEP X)
         60
         Y))
(DEFINE (XIMAGE-F-CREATE_IMAGE X)
        ((LAMBDA (X Y) (CONS 'XIMAGEPROC (MREF-POINTER X Y)))
         (CHK-XIMAGEP X)
         64))
(DEFINE (XIMAGE-F-CREATE_IMAGE! X Y)
        ((LAMBDA (X Y Z) (SET-MREF-POINTER! X Y (CHK-XIMAGEPROC Z)))
         (CHK-XIMAGEP X)
         64
         Y))
(DEFINE (XIMAGE-F-DESTROY_IMAGE X)
        ((LAMBDA (X Y) (CONS 'INTPROC (MREF-POINTER X Y)))
         (CHK-XIMAGEP X)
         68))
(DEFINE (XIMAGE-F-DESTROY_IMAGE! X Y)
        ((LAMBDA (X Y Z) (SET-MREF-POINTER! X Y (CHK-INTPROC Z)))
         (CHK-XIMAGEP X)
         68
         Y))
(DEFINE (XIMAGE-F-GET_PIXEL X)
        ((LAMBDA (X Y) (CONS 'UNSIGNEDPROC (MREF-POINTER X Y)))
         (CHK-XIMAGEP X)
         72))
(DEFINE (XIMAGE-F-GET_PIXEL! X Y)
        ((LAMBDA (X Y Z) (SET-MREF-POINTER! X Y (CHK-UNSIGNEDPROC Z)))
         (CHK-XIMAGEP X)
         72
         Y))
(DEFINE (XIMAGE-F-PUT_PIXEL X)
        ((LAMBDA (X Y) (CONS 'INTPROC (MREF-POINTER X Y)))
         (CHK-XIMAGEP X)
         76))
(DEFINE (XIMAGE-F-PUT_PIXEL! X Y)
        ((LAMBDA (X Y Z) (SET-MREF-POINTER! X Y (CHK-INTPROC Z)))
         (CHK-XIMAGEP X)
         76
         Y))
(DEFINE (XIMAGE-F-SUB_IMAGE X)
        ((LAMBDA (X Y) (CONS 'XIMAGEPROC (MREF-POINTER X Y)))
         (CHK-XIMAGEP X)
         80))
(DEFINE (XIMAGE-F-SUB_IMAGE! X Y)
        ((LAMBDA (X Y Z) (SET-MREF-POINTER! X Y (CHK-XIMAGEPROC Z)))
         (CHK-XIMAGEP X)
         80
         Y))
(DEFINE (XIMAGE-F-ADD_PIXEL X)
        ((LAMBDA (X Y) (CONS 'INTPROC (MREF-POINTER X Y)))
         (CHK-XIMAGEP X)
         84))
(DEFINE (XIMAGE-F-ADD_PIXEL! X Y)
        ((LAMBDA (X Y Z) (SET-MREF-POINTER! X Y (CHK-INTPROC Z)))
         (CHK-XIMAGEP X)
         84
         Y))
