(HERALD XWS3 (ENV TSYS (XLIB INTERFACE)))

(DEFINE-FOREIGN XVISUALIDFROMVISUAL*
                ("XVisualIDFromVisual" (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XVISUALIDFROMVISUAL VISUAL)
        (LET* ((VISUAL (CHK-VISUALP VISUAL))
               (RETURN-VALUE (XVISUALIDFROMVISUAL* VISUAL)))
              RETURN-VALUE))
(DEFINE-FOREIGN XCREATEWINDOW*
                ("XCreateWindow" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XCREATEWINDOW DPY
                       PARENT
                       X
                       Y
                       WIDTH
                       HEIGHT
                       BORDERWIDTH
                       DEPTH
                       CLASS
                       VISUAL
                       VALUEMASK
                       ATTRIBUTES)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (PARENT PARENT)
               (X X)
               (Y Y)
               (WIDTH WIDTH)
               (HEIGHT HEIGHT)
               (BORDERWIDTH BORDERWIDTH)
               (DEPTH DEPTH)
               (CLASS CLASS)
               (VISUAL (CHK-VISUALP VISUAL))
               (VALUEMASK VALUEMASK)
               (ATTRIBUTES (CHK-XSETWINDOWATTRIBUTESP ATTRIBUTES))
               (RETURN-VALUE (XCREATEWINDOW* DPY
                                             PARENT
                                             X
                                             Y
                                             WIDTH
                                             HEIGHT
                                             BORDERWIDTH
                                             DEPTH
                                             CLASS
                                             VISUAL
                                             VALUEMASK
                                             ATTRIBUTES)))
              RETURN-VALUE))
(DEFINE-FOREIGN XCREATESIMPLEWINDOW*
                ("XCreateSimpleWindow" (IN REP/C-POINTER)
                                       (IN REP/INTEGER)
                                       (IN REP/INTEGER)
                                       (IN REP/INTEGER)
                                       (IN REP/INTEGER)
                                       (IN REP/INTEGER)
                                       (IN REP/INTEGER)
                                       (IN REP/INTEGER)
                                       (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XCREATESIMPLEWINDOW DPY
                             PARENT
                             X
                             Y
                             WIDTH
                             HEIGHT
                             BORDERWIDTH
                             BORDER
                             BACKGROUND)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (PARENT PARENT)
               (X X)
               (Y Y)
               (WIDTH WIDTH)
               (HEIGHT HEIGHT)
               (BORDERWIDTH BORDERWIDTH)
               (BORDER BORDER)
               (BACKGROUND BACKGROUND)
               (RETURN-VALUE (XCREATESIMPLEWINDOW* DPY
                                                   PARENT
                                                   X
                                                   Y
                                                   WIDTH
                                                   HEIGHT
                                                   BORDERWIDTH
                                                   BORDER
                                                   BACKGROUND)))
              RETURN-VALUE))
(DEFINE-FOREIGN XDESTROYWINDOW*
                ("XDestroyWindow" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XDESTROYWINDOW DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (RETURN-VALUE (BLOCK (XDESTROYWINDOW* DPY W) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XDESTROYSUBWINDOWS*
                ("XDestroySubwindows" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XDESTROYSUBWINDOWS DPY WIN)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (WIN WIN)
               (RETURN-VALUE (BLOCK (XDESTROYSUBWINDOWS* DPY WIN) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XMAPWINDOW*
                ("XMapWindow" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XMAPWINDOW DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (RETURN-VALUE (BLOCK (XMAPWINDOW* DPY W) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XMAPRAISED*
                ("XMapRaised" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XMAPRAISED DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (RETURN-VALUE (BLOCK (XMAPRAISED* DPY W) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XMAPSUBWINDOWS*
                ("XMapSubwindows" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XMAPSUBWINDOWS DPY WIN)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (WIN WIN)
               (RETURN-VALUE (BLOCK (XMAPSUBWINDOWS* DPY WIN) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XUNMAPWINDOW*
                ("XUnmapWindow" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XUNMAPWINDOW DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (RETURN-VALUE (BLOCK (XUNMAPWINDOW* DPY W) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XUNMAPSUBWINDOWS*
                ("XUnmapSubwindows" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XUNMAPSUBWINDOWS DPY WIN)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (WIN WIN)
               (RETURN-VALUE (BLOCK (XUNMAPSUBWINDOWS* DPY WIN) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCONFIGUREWINDOW*
                ("XConfigureWindow" (IN REP/C-POINTER)
                                    (IN REP/INTEGER)
                                    (IN REP/INTEGER)
                                    (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XCONFIGUREWINDOW DPY W MASK CHANGES)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (MASK MASK)
               (CHANGES (CHK-XWINDOWCHANGESP CHANGES))
               (RETURN-VALUE (BLOCK (XCONFIGUREWINDOW* DPY W MASK CHANGES)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XMOVEWINDOW*
                ("XMoveWindow" (IN REP/C-POINTER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER))
                IGNORE)
(DEFINE (XMOVEWINDOW DPY W X Y)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (X X)
               (Y Y)
               (RETURN-VALUE (BLOCK (XMOVEWINDOW* DPY W X Y) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XRESIZEWINDOW*
                ("XResizeWindow" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER))
                IGNORE)
(DEFINE (XRESIZEWINDOW DPY W WIDTH HEIGHT)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (WIDTH WIDTH)
               (HEIGHT HEIGHT)
               (RETURN-VALUE (BLOCK (XRESIZEWINDOW* DPY W WIDTH HEIGHT)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XMOVERESIZEWINDOW*
                ("XMoveResizeWindow" (IN REP/C-POINTER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER)
                                     (IN REP/INTEGER))
                IGNORE)
(DEFINE (XMOVERESIZEWINDOW DPY W X Y WIDTH HEIGHT)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (X X)
               (Y Y)
               (WIDTH WIDTH)
               (HEIGHT HEIGHT)
               (RETURN-VALUE (BLOCK (XMOVERESIZEWINDOW* DPY W X Y WIDTH HEIGHT)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETWINDOWBORDERWIDTH*
                ("XSetWindowBorderWidth" (IN REP/C-POINTER)
                                         (IN REP/INTEGER)
                                         (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETWINDOWBORDERWIDTH DPY W WIDTH)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (WIDTH WIDTH)
               (RETURN-VALUE (BLOCK (XSETWINDOWBORDERWIDTH* DPY W WIDTH)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XRAISEWINDOW*
                ("XRaiseWindow" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XRAISEWINDOW DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (RETURN-VALUE (BLOCK (XRAISEWINDOW* DPY W) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XLOWERWINDOW*
                ("XLowerWindow" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XLOWERWINDOW DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (RETURN-VALUE (BLOCK (XLOWERWINDOW* DPY W) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCIRCULATESUBWINDOWS*
                ("XCirculateSubwindows" (IN REP/C-POINTER)
                                        (IN REP/INTEGER)
                                        (IN REP/INTEGER))
                IGNORE)
(DEFINE (XCIRCULATESUBWINDOWS DPY W DIRECTION)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (DIRECTION DIRECTION)
               (RETURN-VALUE (BLOCK (XCIRCULATESUBWINDOWS* DPY W DIRECTION)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCIRCULATESUBWINDOWSUP*
                ("XCirculateSubwindowsUp" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XCIRCULATESUBWINDOWSUP DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (RETURN-VALUE (BLOCK (XCIRCULATESUBWINDOWSUP* DPY W) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCIRCULATESUBWINDOWSDOWN*
                ("XCirculateSubwindowsDown" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XCIRCULATESUBWINDOWSDOWN DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (RETURN-VALUE (BLOCK (XCIRCULATESUBWINDOWSDOWN* DPY W)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XRESTACKWINDOWS*
                ("XRestackWindows" (IN REP/C-POINTER)
                                   (IN REP/C-POINTER)
                                   (IN REP/INTEGER))
                IGNORE)
(DEFINE (XRESTACKWINDOWS DPY WINDOWS COUNT)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (WINDOWS (CHK-UNSIGNEDAP WINDOWS))
               (COUNT COUNT)
               (RETURN-VALUE (BLOCK (XRESTACKWINDOWS* DPY WINDOWS COUNT)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCHANGEWINDOWATTRIBUTES*
                ("XChangeWindowAttributes" (IN REP/C-POINTER)
                                           (IN REP/INTEGER)
                                           (IN REP/INTEGER)
                                           (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XCHANGEWINDOWATTRIBUTES DPY W VALUEMASK ATTRIBUTES)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (VALUEMASK VALUEMASK)
               (ATTRIBUTES (CHK-XSETWINDOWATTRIBUTESP ATTRIBUTES))
               (RETURN-VALUE (BLOCK (XCHANGEWINDOWATTRIBUTES* DPY
                                                              W
                                                              VALUEMASK
                                                              ATTRIBUTES)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETWINDOWBACKGROUND*
                ("XSetWindowBackground" (IN REP/C-POINTER)
                                        (IN REP/INTEGER)
                                        (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETWINDOWBACKGROUND DPY W PIXEL)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (PIXEL PIXEL)
               (RETURN-VALUE (BLOCK (XSETWINDOWBACKGROUND* DPY W PIXEL)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETWINDOWBACKGROUNDPIXMAP*
                ("XSetWindowBackgroundPixmap" (IN REP/C-POINTER)
                                              (IN REP/INTEGER)
                                              (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETWINDOWBACKGROUNDPIXMAP DPY W PIXMAP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (PIXMAP PIXMAP)
               (RETURN-VALUE (BLOCK (XSETWINDOWBACKGROUNDPIXMAP* DPY W PIXMAP)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETWINDOWBORDER*
                ("XSetWindowBorder" (IN REP/C-POINTER)
                                    (IN REP/INTEGER)
                                    (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETWINDOWBORDER DPY W PIXEL)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (PIXEL PIXEL)
               (RETURN-VALUE (BLOCK (XSETWINDOWBORDER* DPY W PIXEL) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETWINDOWBORDERPIXMAP*
                ("XSetWindowBorderPixmap" (IN REP/C-POINTER)
                                          (IN REP/INTEGER)
                                          (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETWINDOWBORDERPIXMAP DPY W PIXMAP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (PIXMAP PIXMAP)
               (RETURN-VALUE (BLOCK (XSETWINDOWBORDERPIXMAP* DPY W PIXMAP)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XTRANSLATECOORDINATES*
                ("XTranslateCoordinates" (IN REP/C-POINTER)
                                         (IN REP/INTEGER)
                                         (IN REP/INTEGER)
                                         (IN REP/INTEGER)
                                         (IN REP/INTEGER)
                                         (IN REP/EXTEND)
                                         (IN REP/EXTEND)
                                         (IN REP/EXTEND))
                REP/INTEGER)
(DEFINE (XTRANSLATECOORDINATES DPY SRC_WIN DEST_WIN SRC_X SRC_Y)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SRC_WIN SRC_WIN)
               (DEST_WIN DEST_WIN)
               (SRC_X SRC_X)
               (SRC_Y SRC_Y)
               (DST_X (MAKE-BYTEV 4))
               (DST_Y (MAKE-BYTEV 4))
               (CHILD (MAKE-BYTEV 4))
               (RETURN-VALUE (XTRANSLATECOORDINATES* DPY
                                                     SRC_WIN
                                                     DEST_WIN
                                                     SRC_X
                                                     SRC_Y
                                                     DST_X
                                                     DST_Y
                                                     CHILD)))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER DST_X 0)
                      (MREF-INTEGER DST_Y 0)
                      (MREF-INTEGER CHILD 0))))
