(HERALD XWS7 (ENV TSYS (XLIB INTERFACE)))

(DEFINE-FOREIGN XREPARENTWINDOW*
                ("XReparentWindow" (IN REP/C-POINTER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER))
                IGNORE)
(DEFINE (XREPARENTWINDOW DPY W P X Y)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (P P)
               (X X)
               (Y Y)
               (RETURN-VALUE (BLOCK (XREPARENTWINDOW* DPY W P X Y) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCHANGESAVESET*
                ("XChangeSaveSet" (IN REP/C-POINTER)
                                  (IN REP/INTEGER)
                                  (IN REP/INTEGER))
                IGNORE)
(DEFINE (XCHANGESAVESET DPY WIN MODE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (WIN WIN)
               (MODE MODE)
               (RETURN-VALUE (BLOCK (XCHANGESAVESET* DPY WIN MODE) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XADDTOSAVESET*
                ("XAddToSaveSet" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XADDTOSAVESET DPY WIN)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (WIN WIN)
               (RETURN-VALUE (BLOCK (XADDTOSAVESET* DPY WIN) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XREMOVEFROMSAVESET*
                ("XRemoveFromSaveSet" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XREMOVEFROMSAVESET DPY WIN)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (WIN WIN)
               (RETURN-VALUE (BLOCK (XREMOVEFROMSAVESET* DPY WIN) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XINSTALLCOLORMAP*
                ("XInstallColormap" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XINSTALLCOLORMAP DPY CMAP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (RETURN-VALUE (BLOCK (XINSTALLCOLORMAP* DPY CMAP) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XUNINSTALLCOLORMAP*
                ("XUninstallColormap" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XUNINSTALLCOLORMAP DPY CMAP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (CMAP CMAP)
               (RETURN-VALUE (BLOCK (XUNINSTALLCOLORMAP* DPY CMAP) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XLISTINSTALLEDCOLORMAPS*
                ("XListInstalledColormaps" (IN REP/C-POINTER)
                                           (IN REP/INTEGER)
                                           (IN REP/EXTEND))
                REP/POINTER)
(DEFINE (XLISTINSTALLEDCOLORMAPS DPY W)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (W W)
               (NUM (MAKE-BYTEV 4))
               (RETURN-VALUE (CONS 'UNSIGNEDAP
                                   (XLISTINSTALLEDCOLORMAPS* DPY W NUM))))
              (RETURN RETURN-VALUE (MREF-INTEGER NUM 0))))
(DEFINE-FOREIGN XGRABPOINTER*
                ("XGrabPointer" (IN REP/C-POINTER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XGRABPOINTER DPY
                      GRAB_WINDOW
                      OWNER_EVENTS
                      EVENT_MASK
                      POINTER_MODE
                      KEYBOARD_MODE
                      CONFINE_TO
                      CURS
                      TIME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (GRAB_WINDOW GRAB_WINDOW)
               (OWNER_EVENTS OWNER_EVENTS)
               (EVENT_MASK EVENT_MASK)
               (POINTER_MODE POINTER_MODE)
               (KEYBOARD_MODE KEYBOARD_MODE)
               (CONFINE_TO CONFINE_TO)
               (CURS CURS)
               (TIME TIME)
               (RETURN-VALUE (XGRABPOINTER* DPY
                                            GRAB_WINDOW
                                            OWNER_EVENTS
                                            EVENT_MASK
                                            POINTER_MODE
                                            KEYBOARD_MODE
                                            CONFINE_TO
                                            CURS
                                            TIME)))
              RETURN-VALUE))
(DEFINE-FOREIGN XUNGRABPOINTER*
                ("XUngrabPointer" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XUNGRABPOINTER DPY TIME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (TIME TIME)
               (RETURN-VALUE (BLOCK (XUNGRABPOINTER* DPY TIME) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCHANGEACTIVEPOINTERGRAB*
                ("XChangeActivePointerGrab" (IN REP/C-POINTER)
                                            (IN REP/INTEGER)
                                            (IN REP/INTEGER)
                                            (IN REP/INTEGER))
                IGNORE)
(DEFINE (XCHANGEACTIVEPOINTERGRAB DPY EVENT_MASK CURS TIME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (EVENT_MASK EVENT_MASK)
               (CURS CURS)
               (TIME TIME)
               (RETURN-VALUE (BLOCK (XCHANGEACTIVEPOINTERGRAB* DPY
                                                               EVENT_MASK
                                                               CURS
                                                               TIME)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGRABBUTTON*
                ("XGrabButton" (IN REP/C-POINTER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER)
                               (IN REP/INTEGER))
                IGNORE)
(DEFINE (XGRABBUTTON DPY
                     BUTTON
                     MODIFIERS
                     GRAB_WINDOW
                     OWNER_EVENTS
                     EVENT_MASK
                     POINTER_MODE
                     KEYBOARD_MODE
                     CONFINE_TO
                     CURS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (BUTTON BUTTON)
               (MODIFIERS MODIFIERS)
               (GRAB_WINDOW GRAB_WINDOW)
               (OWNER_EVENTS OWNER_EVENTS)
               (EVENT_MASK EVENT_MASK)
               (POINTER_MODE POINTER_MODE)
               (KEYBOARD_MODE KEYBOARD_MODE)
               (CONFINE_TO CONFINE_TO)
               (CURS CURS)
               (RETURN-VALUE (BLOCK (XGRABBUTTON* DPY
                                                  BUTTON
                                                  MODIFIERS
                                                  GRAB_WINDOW
                                                  OWNER_EVENTS
                                                  EVENT_MASK
                                                  POINTER_MODE
                                                  KEYBOARD_MODE
                                                  CONFINE_TO
                                                  CURS)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XUNGRABBUTTON*
                ("XUngrabButton" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER))
                IGNORE)
(DEFINE (XUNGRABBUTTON DPY BUTTON MODIFIERS GRAB_WINDOW)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (BUTTON BUTTON)
               (MODIFIERS MODIFIERS)
               (GRAB_WINDOW GRAB_WINDOW)
               (RETURN-VALUE (BLOCK (XUNGRABBUTTON* DPY
                                                    BUTTON
                                                    MODIFIERS
                                                    GRAB_WINDOW)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGRABKEYBOARD*
                ("XGrabKeyboard" (IN REP/C-POINTER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER)
                                 (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XGRABKEYBOARD DPY WINDOW OWNEREVENTS POINTERMODE KEYBOARDMODE TIME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (WINDOW WINDOW)
               (OWNEREVENTS OWNEREVENTS)
               (POINTERMODE POINTERMODE)
               (KEYBOARDMODE KEYBOARDMODE)
               (TIME TIME)
               (RETURN-VALUE (XGRABKEYBOARD* DPY
                                             WINDOW
                                             OWNEREVENTS
                                             POINTERMODE
                                             KEYBOARDMODE
                                             TIME)))
              RETURN-VALUE))
(DEFINE-FOREIGN XUNGRABKEYBOARD*
                ("XUngrabKeyboard" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XUNGRABKEYBOARD DPY TIME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (TIME TIME)
               (RETURN-VALUE (BLOCK (XUNGRABKEYBOARD* DPY TIME) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGRABKEY*
                ("XGrabKey" (IN REP/C-POINTER)
                            (IN REP/INTEGER)
                            (IN REP/INTEGER)
                            (IN REP/INTEGER)
                            (IN REP/INTEGER)
                            (IN REP/INTEGER)
                            (IN REP/INTEGER))
                IGNORE)
(DEFINE (XGRABKEY DPY
                  KEY
                  MODIFIERS
                  GRAB_WINDOW
                  OWNER_EVENTS
                  POINTER_MODE
                  KEYBOARD_MODE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (KEY KEY)
               (MODIFIERS MODIFIERS)
               (GRAB_WINDOW GRAB_WINDOW)
               (OWNER_EVENTS OWNER_EVENTS)
               (POINTER_MODE POINTER_MODE)
               (KEYBOARD_MODE KEYBOARD_MODE)
               (RETURN-VALUE (BLOCK (XGRABKEY* DPY
                                               KEY
                                               MODIFIERS
                                               GRAB_WINDOW
                                               OWNER_EVENTS
                                               POINTER_MODE
                                               KEYBOARD_MODE)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XUNGRABKEY*
                ("XUngrabKey" (IN REP/C-POINTER)
                              (IN REP/INTEGER)
                              (IN REP/INTEGER)
                              (IN REP/INTEGER))
                IGNORE)
(DEFINE (XUNGRABKEY DPY KEY MODIFIERS GRAB_WINDOW)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (KEY KEY)
               (MODIFIERS MODIFIERS)
               (GRAB_WINDOW GRAB_WINDOW)
               (RETURN-VALUE (BLOCK (XUNGRABKEY* DPY KEY MODIFIERS GRAB_WINDOW)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XALLOWEVENTS*
                ("XAllowEvents" (IN REP/C-POINTER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER))
                IGNORE)
(DEFINE (XALLOWEVENTS DPY MODE TIME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (MODE MODE)
               (TIME TIME)
               (RETURN-VALUE (BLOCK (XALLOWEVENTS* DPY MODE TIME) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGRABSERVER* ("XGrabServer" (IN REP/C-POINTER)) IGNORE)
(DEFINE (XGRABSERVER DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XGRABSERVER* DPY) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XUNGRABSERVER* ("XUngrabServer" (IN REP/C-POINTER)) IGNORE)
(DEFINE (XUNGRABSERVER DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XUNGRABSERVER* DPY) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XWARPPOINTER*
                ("XWarpPointer" (IN REP/C-POINTER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER)
                                (IN REP/INTEGER))
                IGNORE)
(DEFINE (XWARPPOINTER DPY
                      SRC_WIN
                      DEST_WIN
                      SRC_X
                      SRC_Y
                      SRC_WIDTH
                      SRC_HEIGHT
                      DEST_X
                      DEST_Y)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (SRC_WIN SRC_WIN)
               (DEST_WIN DEST_WIN)
               (SRC_X SRC_X)
               (SRC_Y SRC_Y)
               (SRC_WIDTH SRC_WIDTH)
               (SRC_HEIGHT SRC_HEIGHT)
               (DEST_X DEST_X)
               (DEST_Y DEST_Y)
               (RETURN-VALUE (BLOCK (XWARPPOINTER* DPY
                                                   SRC_WIN
                                                   DEST_WIN
                                                   SRC_X
                                                   SRC_Y
                                                   SRC_WIDTH
                                                   SRC_HEIGHT
                                                   DEST_X
                                                   DEST_Y)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETINPUTFOCUS*
                ("XSetInputFocus" (IN REP/C-POINTER)
                                  (IN REP/INTEGER)
                                  (IN REP/INTEGER)
                                  (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETINPUTFOCUS DPY FOCUS REVERT_TO TIME)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (FOCUS FOCUS)
               (REVERT_TO REVERT_TO)
               (TIME TIME)
               (RETURN-VALUE (BLOCK (XSETINPUTFOCUS* DPY FOCUS REVERT_TO TIME)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETINPUTFOCUS*
                ("XGetInputFocus" (IN REP/C-POINTER)
                                  (IN REP/EXTEND)
                                  (IN REP/EXTEND))
                IGNORE)
(DEFINE (XGETINPUTFOCUS DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (FOCUS (MAKE-BYTEV 4))
               (REVERT_TO (MAKE-BYTEV 4))
               (RETURN-VALUE (BLOCK (XGETINPUTFOCUS* DPY FOCUS REVERT_TO)
                                    '())))
              (RETURN (MREF-INTEGER FOCUS 0) (MREF-INTEGER REVERT_TO 0))))
(DEFINE-FOREIGN XSETCLOSEDOWNMODE*
                ("XSetCloseDownMode" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETCLOSEDOWNMODE DPY MODE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (MODE MODE)
               (RETURN-VALUE (BLOCK (XSETCLOSEDOWNMODE* DPY MODE) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XKILLCLIENT*
                ("XKillClient" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XKILLCLIENT DPY RESOURCE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RESOURCE RESOURCE)
               (RETURN-VALUE (BLOCK (XKILLCLIENT* DPY RESOURCE) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XCHANGEKEYBOARDCONTROL*
                ("XChangeKeyboardControl" (IN REP/C-POINTER)
                                          (IN REP/INTEGER)
                                          (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XCHANGEKEYBOARDCONTROL DPY MASK VALUE_LIST)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (MASK MASK)
               (VALUE_LIST (CHK-XKEYBOARDCONTROLP VALUE_LIST))
               (RETURN-VALUE (BLOCK (XCHANGEKEYBOARDCONTROL* DPY
                                                             MASK
                                                             VALUE_LIST)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETKEYBOARDCONTROL*
                ("XGetKeyboardControl" (IN REP/C-POINTER) (IN REP/EXTEND))
                IGNORE)
(DEFINE (XGETKEYBOARDCONTROL DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (STATE (MAKE-BYTEV 56))
               (RETURN-VALUE (BLOCK (XGETKEYBOARDCONTROL* DPY STATE) '())))
              (CONS 'XKEYBOARDSTATEP STATE)))
(DEFINE-FOREIGN XAUTOREPEATON* ("XAutoRepeatOn" (IN REP/C-POINTER)) IGNORE)
(DEFINE (XAUTOREPEATON DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XAUTOREPEATON* DPY) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XAUTOREPEATOFF* ("XAutoRepeatOff" (IN REP/C-POINTER)) IGNORE)
(DEFINE (XAUTOREPEATOFF DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XAUTOREPEATOFF* DPY) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XBELL* ("XBell" (IN REP/C-POINTER) (IN REP/INTEGER)) IGNORE)
(DEFINE (XBELL DPY PERCENT)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (PERCENT PERCENT)
               (RETURN-VALUE (BLOCK (XBELL* DPY PERCENT) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XQUERYKEYMAP*
                ("XQueryKeymap" (IN REP/C-POINTER) (IN REP/EXTEND))
                IGNORE)
(DEFINE (XQUERYKEYMAP DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (KEYS (MAKE-BYTEV 32))
               (RETURN-VALUE (BLOCK (XQUERYKEYMAP* DPY KEYS) '())))
              (CONS 'XQKEYMAPP KEYS)))
(DEFINE-FOREIGN XSETPOINTERMAPPING*
                ("XSetPointerMapping" (IN REP/C-POINTER)
                                      (IN REP/C-POINTER)
                                      (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XSETPOINTERMAPPING DPY MAP NMAPS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (MAP (CHK-CHARAP MAP))
               (NMAPS NMAPS)
               (RETURN-VALUE (XSETPOINTERMAPPING* DPY MAP NMAPS)))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETPOINTERMAPPING*
                ("XGetPointerMapping" (IN REP/C-POINTER)
                                      (IN REP/C-POINTER)
                                      (IN REP/INTEGER))
                REP/INTEGER)
(DEFINE (XGETPOINTERMAPPING DPY MAP NMAPS)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (MAP (CHK-CHARAP MAP))
               (NMAPS NMAPS)
               (RETURN-VALUE (XGETPOINTERMAPPING* DPY MAP NMAPS)))
              RETURN-VALUE))
(DEFINE-FOREIGN XCHANGEPOINTERCONTROL*
                ("XChangePointerControl" (IN REP/C-POINTER)
                                         (IN REP/INTEGER)
                                         (IN REP/INTEGER)
                                         (IN REP/INTEGER)
                                         (IN REP/INTEGER)
                                         (IN REP/INTEGER))
                IGNORE)
(DEFINE (XCHANGEPOINTERCONTROL DPY
                               DO_ACC
                               DO_THRESH
                               ACC_NUMERATOR
                               ACC_DENOMINATOR
                               THRESHOLD)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (DO_ACC DO_ACC)
               (DO_THRESH DO_THRESH)
               (ACC_NUMERATOR ACC_NUMERATOR)
               (ACC_DENOMINATOR ACC_DENOMINATOR)
               (THRESHOLD THRESHOLD)
               (RETURN-VALUE (BLOCK (XCHANGEPOINTERCONTROL* DPY
                                                            DO_ACC
                                                            DO_THRESH
                                                            ACC_NUMERATOR
                                                            ACC_DENOMINATOR
                                                            THRESHOLD)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETPOINTERCONTROL*
                ("XGetPointerControl" (IN REP/C-POINTER)
                                      (IN REP/EXTEND)
                                      (IN REP/EXTEND)
                                      (IN REP/EXTEND))
                IGNORE)
(DEFINE (XGETPOINTERCONTROL DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (ACCEL_NUMER (MAKE-BYTEV 4))
               (ACCEL_DENOM (MAKE-BYTEV 4))
               (THRESHOLD (MAKE-BYTEV 4))
               (RETURN-VALUE (BLOCK (XGETPOINTERCONTROL* DPY
                                                         ACCEL_NUMER
                                                         ACCEL_DENOM
                                                         THRESHOLD)
                                    '())))
              (RETURN (MREF-INTEGER ACCEL_NUMER 0)
                      (MREF-INTEGER ACCEL_DENOM 0)
                      (MREF-INTEGER THRESHOLD 0))))
(DEFINE-FOREIGN XDISPLAYKEYCODES*
                ("XDisplayKeycodes" (IN REP/C-POINTER)
                                    (IN REP/EXTEND)
                                    (IN REP/EXTEND))
                IGNORE)
(DEFINE (XDISPLAYKEYCODES DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (MIN_KEYCODE_RETURN (MAKE-BYTEV 4))
               (MAX_KEYCODE_RETURN (MAKE-BYTEV 4))
               (RETURN-VALUE (BLOCK (XDISPLAYKEYCODES* DPY
                                                       MIN_KEYCODE_RETURN
                                                       MAX_KEYCODE_RETURN)
                                    '())))
              (RETURN (MREF-INTEGER MIN_KEYCODE_RETURN 0)
                      (MREF-INTEGER MAX_KEYCODE_RETURN 0))))
(DEFINE-FOREIGN XGETKEYBOARDMAPPING*
                ("XGetKeyboardMapping" (IN REP/C-POINTER)
                                       (IN REP/CHAR)
                                       (IN REP/INTEGER)
                                       (IN REP/EXTEND))
                REP/POINTER)
(DEFINE (XGETKEYBOARDMAPPING DPY FIRST_KEYCODE COUNT)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (FIRST_KEYCODE FIRST_KEYCODE)
               (COUNT COUNT)
               (KEYSYMS_PER_KEYCODE (MAKE-BYTEV 4))
               (RETURN-VALUE (CONS 'UNSIGNEDAP
                                   (XGETKEYBOARDMAPPING* DPY
                                                         FIRST_KEYCODE
                                                         COUNT
                                                         KEYSYMS_PER_KEYCODE))))
              (RETURN RETURN-VALUE (MREF-INTEGER KEYSYMS_PER_KEYCODE 0))))
(DEFINE-FOREIGN XCHANGEKEYBOARDMAPPING*
                ("XChangeKeyboardMapping" (IN REP/C-POINTER)
                                          (IN REP/INTEGER)
                                          (IN REP/INTEGER)
                                          (IN REP/C-POINTER)
                                          (IN REP/INTEGER))
                IGNORE)
(DEFINE (XCHANGEKEYBOARDMAPPING DPY
                                FIRST_KEYCODE
                                KEYSYMS_PER_KEYCODE
                                KEYSYMS
                                NKEYCODES)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (FIRST_KEYCODE FIRST_KEYCODE)
               (KEYSYMS_PER_KEYCODE KEYSYMS_PER_KEYCODE)
               (KEYSYMS (CHK-UNSIGNEDAP KEYSYMS))
               (NKEYCODES NKEYCODES)
               (RETURN-VALUE (BLOCK (XCHANGEKEYBOARDMAPPING* DPY
                                                             FIRST_KEYCODE
                                                             KEYSYMS_PER_KEYCODE
                                                             KEYSYMS
                                                             NKEYCODES)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XNEWMODIFIERMAP*
                ("XNewModifiermap" (IN REP/INTEGER))
                REP/POINTER)
(DEFINE (XNEWMODIFIERMAP KEYSPERMODIFIER)
        (LET* ((KEYSPERMODIFIER KEYSPERMODIFIER)
               (RETURN-VALUE (CONS 'XMODIFIERKEYMAPP
                                   (XNEWMODIFIERMAP* KEYSPERMODIFIER))))
              RETURN-VALUE))
(DEFINE-FOREIGN XINSERTMODIFIERMAPENTRY*
                ("XInsertModifiermapEntry" (IN REP/C-POINTER)
                                           (IN REP/CHAR)
                                           (IN REP/INTEGER))
                REP/POINTER)
(DEFINE (XINSERTMODIFIERMAPENTRY MAP KEYSYM MODIFIER)
        (LET* ((MAP (CHK-XMODIFIERKEYMAPP MAP))
               (KEYSYM KEYSYM)
               (MODIFIER MODIFIER)
               (RETURN-VALUE (CONS 'XMODIFIERKEYMAPP
                                   (XINSERTMODIFIERMAPENTRY* MAP
                                                             KEYSYM
                                                             MODIFIER))))
              RETURN-VALUE))
(DEFINE-FOREIGN XDELETEMODIFIERMAPENTRY*
                ("XDeleteModifiermapEntry" (IN REP/C-POINTER)
                                           (IN REP/CHAR)
                                           (IN REP/INTEGER))
                REP/POINTER)
(DEFINE (XDELETEMODIFIERMAPENTRY MAP KEYSYM MODIFIER)
        (LET* ((MAP (CHK-XMODIFIERKEYMAPP MAP))
               (KEYSYM KEYSYM)
               (MODIFIER MODIFIER)
               (RETURN-VALUE (CONS 'XMODIFIERKEYMAPP
                                   (XDELETEMODIFIERMAPENTRY* MAP
                                                             KEYSYM
                                                             MODIFIER))))
              RETURN-VALUE))
(DEFINE-FOREIGN XFREEMODIFIERMAP*
                ("XFreeModifiermap" (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XFREEMODIFIERMAP MAP)
        (LET* ((MAP (CHK-XMODIFIERKEYMAPP MAP))
               (RETURN-VALUE (BLOCK (XFREEMODIFIERMAP* MAP) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETMODIFIERMAPPING*
                ("XSetModifierMapping" (IN REP/C-POINTER) (IN REP/C-POINTER))
                REP/INTEGER)
(DEFINE (XSETMODIFIERMAPPING DPY MODIFIER_MAP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (MODIFIER_MAP (CHK-XMODIFIERKEYMAPP MODIFIER_MAP))
               (RETURN-VALUE (XSETMODIFIERMAPPING* DPY MODIFIER_MAP)))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETMODIFIERMAPPING*
                ("XGetModifierMapping" (IN REP/C-POINTER))
                REP/POINTER)
(DEFINE (XGETMODIFIERMAPPING DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (CONS 'XMODIFIERKEYMAPP
                                   (XGETMODIFIERMAPPING* DPY))))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETSCREENSAVER*
                ("XSetScreenSaver" (IN REP/C-POINTER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER)
                                   (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETSCREENSAVER DPY TIMEOUT INTERVAL PREFER_BLANK ALLOW_EXP)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (TIMEOUT TIMEOUT)
               (INTERVAL INTERVAL)
               (PREFER_BLANK PREFER_BLANK)
               (ALLOW_EXP ALLOW_EXP)
               (RETURN-VALUE (BLOCK (XSETSCREENSAVER* DPY
                                                      TIMEOUT
                                                      INTERVAL
                                                      PREFER_BLANK
                                                      ALLOW_EXP)
                                    '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XFORCESCREENSAVER*
                ("XForceScreenSaver" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XFORCESCREENSAVER DPY MODE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (MODE MODE)
               (RETURN-VALUE (BLOCK (XFORCESCREENSAVER* DPY MODE) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XACTIVATESCREENSAVER*
                ("XActivateScreenSaver" (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XACTIVATESCREENSAVER DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XACTIVATESCREENSAVER* DPY) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XRESETSCREENSAVER*
                ("XResetScreenSaver" (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XRESETSCREENSAVER DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XRESETSCREENSAVER* DPY) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XGETSCREENSAVER*
                ("XGetScreenSaver" (IN REP/C-POINTER)
                                   (IN REP/EXTEND)
                                   (IN REP/EXTEND)
                                   (IN REP/EXTEND)
                                   (IN REP/EXTEND))
                IGNORE)
(DEFINE (XGETSCREENSAVER DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (TIMEOUT (MAKE-BYTEV 4))
               (INTERVAL (MAKE-BYTEV 4))
               (PREFER_BLANKING (MAKE-BYTEV 4))
               (ALLOW_EXP (MAKE-BYTEV 4))
               (RETURN-VALUE (BLOCK (XGETSCREENSAVER* DPY
                                                      TIMEOUT
                                                      INTERVAL
                                                      PREFER_BLANKING
                                                      ALLOW_EXP)
                                    '())))
              (RETURN (MREF-INTEGER TIMEOUT 0)
                      (MREF-INTEGER INTERVAL 0)
                      (MREF-INTEGER PREFER_BLANKING 0)
                      (MREF-INTEGER ALLOW_EXP 0))))
(DEFINE-FOREIGN XADDHOST*
                ("XAddHost" (IN REP/C-POINTER) (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XADDHOST DPY HOST)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (HOST (CHK-XHOSTADDRESSP HOST))
               (RETURN-VALUE (BLOCK (XADDHOST* DPY HOST) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XADDHOSTS*
                ("XAddHosts" (IN REP/C-POINTER)
                             (IN REP/C-POINTER)
                             (IN REP/INTEGER))
                IGNORE)
(DEFINE (XADDHOSTS DPY HOSTS N)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (HOSTS (CHK-XHOSTADDRESSAP HOSTS))
               (N N)
               (RETURN-VALUE (BLOCK (XADDHOSTS* DPY HOSTS N) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XLISTHOSTS*
                ("XListHosts" (IN REP/C-POINTER)
                              (IN REP/EXTEND)
                              (IN REP/EXTEND))
                REP/POINTER)
(DEFINE (XLISTHOSTS DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (NHOSTS (MAKE-BYTEV 4))
               (ENABLED (MAKE-BYTEV 4))
               (RETURN-VALUE (CONS 'XHOSTADDRESSAP
                                   (XLISTHOSTS* DPY NHOSTS ENABLED))))
              (RETURN RETURN-VALUE
                      (MREF-INTEGER NHOSTS 0)
                      (MREF-INTEGER ENABLED 0))))
(DEFINE-FOREIGN XREMOVEHOST*
                ("XRemoveHost" (IN REP/C-POINTER) (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XREMOVEHOST DPY HOST)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (HOST (CHK-XHOSTADDRESSP HOST))
               (RETURN-VALUE (BLOCK (XREMOVEHOST* DPY HOST) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XREMOVEHOSTS*
                ("XRemoveHosts" (IN REP/C-POINTER)
                                (IN REP/C-POINTER)
                                (IN REP/INTEGER))
                IGNORE)
(DEFINE (XREMOVEHOSTS DPY HOSTS N)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (HOSTS (CHK-XHOSTADDRESSAP HOSTS))
               (N N)
               (RETURN-VALUE (BLOCK (XREMOVEHOSTS* DPY HOSTS N) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XSETACCESSCONTROL*
                ("XSetAccessControl" (IN REP/C-POINTER) (IN REP/INTEGER))
                IGNORE)
(DEFINE (XSETACCESSCONTROL DPY MODE)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (MODE MODE)
               (RETURN-VALUE (BLOCK (XSETACCESSCONTROL* DPY MODE) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XENABLEACCESSCONTROL*
                ("XEnableAccessControl" (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XENABLEACCESSCONTROL DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XENABLEACCESSCONTROL* DPY) '())))
              RETURN-VALUE))
(DEFINE-FOREIGN XDISABLEACCESSCONTROL*
                ("XDisableAccessControl" (IN REP/C-POINTER))
                IGNORE)
(DEFINE (XDISABLEACCESSCONTROL DPY)
        (LET* ((DPY (CHK-DISPLAYP DPY))
               (RETURN-VALUE (BLOCK (XDISABLEACCESSCONTROL* DPY) '())))
              RETURN-VALUE))
